import java.util.ArrayList;

public class ReceivePacket {
	/**
	 * URG-X002S fR[h@(Sensor->Host)
	 * 
	 * pPbg̃vgR(ׂASCIIR[h) [Command]-[Parameter]-LF-[Status]-LF-[Data
	 * 1]---[Data N]-LF-LF
	 * 
	 * 
	 */

	private String command;

	private String param;

	private String status;

	private ArrayList<Integer> distanceData;

	public ReceivePacket() {
		distanceData = new ArrayList<Integer>();
	}

	public ReceivePacket(String command, String param, String status,
			ArrayList<Integer> distanceData) {
		this.command = command;
		this.param = param;
		this.status = status;
		this.distanceData = distanceData;
	}

	public String getCommand() {
		return command;
	}

	public ArrayList<Integer> getDistanceData() {
		return distanceData;
	}

	public String getParam() {
		return param;
	}

	public String getStatus() {
		return status;
	}

	public void setCommand(String command) {
		this.command = command;
	}

	public void setDistanceData(ArrayList<Integer> data) {
		this.distanceData = data;
	}

	public void setParam(String param) {
		this.param = param;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	@Override
	public String toString() {
		// TODO Auto-generated method stub
		StringBuilder builder = new StringBuilder();
		builder.append("\ndata=\n\n");
		for (Object value : distanceData) {
			builder.append(value + "\n");
		}
		builder.append("\nlevel=\n\n");
		return "Command:" + command + " Parameter:" + param + " Status:"
				+ status + "\nDistanceData(" + distanceData.size() + ")" + "\n"
				+ builder;
	}
}
