
import java.awt.geom.Point2D;
import java.util.List;
import java.util.Vector;

/**
 * @author akichika * Last update: 2005/5/24
 */
public class ScanDataFormatter {

	public static final int ERROR_THRESHOLD_DISTANCE_MIN = 20; // 20ȉ͖炩ɃG[Ɣf

	// for URG

	public static final int ERROR_THRESHOLD_DISTANCE_MAX = 10000; // 10000ȏ͖炩ɃG[Ɣf

	// for URG

	public static Point2D getPoint2D(double angleDegrees, double distanceMillis) {
		double x = -distanceMillis * Math.sin(Math.toRadians(angleDegrees));
		double y = distanceMillis * Math.cos(Math.toRadians(angleDegrees));
		Point2D point = new Point2D.Double(x, y);
		return point;
	}

	public static List<Point2D> getPoint2DListFromScanDataList(List rawData,
			double interval) {

		List<Point2D> points = new Vector<Point2D>();

		int num = rawData.size();
		double angle;

		// logger.info("rawData size:"+num);
		if (num % 2 == 1) {// vf̏ꍇ
			// O

			int max = (int) ((num - 1) / 2);
			for (int i = 0; i < max; i++) {
				int distance = ((Integer) rawData.get(i)).intValue();
				angle = -(interval * (max - i));
				if (distance >= ERROR_THRESHOLD_DISTANCE_MIN
						&& distance <= ERROR_THRESHOLD_DISTANCE_MAX) {
					Point2D point = getPoint2D(angle, (double) distance);
					points.add(point);
				} else
					points.add(new Point2D.Double(0.0, 0.0));

			}

			// 
			{
				int distance = ((Integer) rawData.get(max)).intValue();

				// logger.info("Center Point [distance] = "+distance);

				if (distance >= ERROR_THRESHOLD_DISTANCE_MIN
						&& distance <= ERROR_THRESHOLD_DISTANCE_MAX) {
					Point2D point = getPoint2D(0.0, (double) distance);
					points.add(point);
				} else
					points.add(new Point2D.Double(0.0, 0.0));

			}

			// 㔼
			for (int i = 1; i <= max; i++) {
				int distance = ((Integer) rawData.get(max + i)).intValue();
				angle = (interval * i);
				if (distance >= ERROR_THRESHOLD_DISTANCE_MIN
						&& distance <= ERROR_THRESHOLD_DISTANCE_MAX) {
					Point2D point = getPoint2D(angle, (double) distance);
					points.add(point);
				} else
					points.add(new Point2D.Double(0.0, 0.0));

			}
		} else {// vf̏ꍇ
			double angleBias = interval / 2;// ɂ̓f[^BC^[o̔ꂽƂ납f[^n܂B

			int max = (int) (num / 2);
			// O
			for (int i = 0; i < max; i++) {
				int distance = ((Integer) rawData.get(i)).intValue();
				angle = angleBias - (interval * (max - i));
				if (distance >= ERROR_THRESHOLD_DISTANCE_MIN
						&& distance <= ERROR_THRESHOLD_DISTANCE_MAX) {
					Point2D point = getPoint2D(angle, (double) distance);
					points.add(point);
				} else
					points.add(new Point2D.Double(0.0, 0.0));

			}

			// 㔼
			for (int i = 0; i < max; i++) {
				int distance = ((Integer) rawData.get(max + i)).intValue();
				angle = angleBias + (interval * i);
				if (distance >= ERROR_THRESHOLD_DISTANCE_MIN
						&& distance <= ERROR_THRESHOLD_DISTANCE_MAX) {
					Point2D point = getPoint2D(angle, (double) distance);
					points.add(point);
				} else
					points.add(new Point2D.Double(0.0, 0.0));

			}
		}
		return points;
	}
	/*
	 * public static List getPoint2DListDummyWithDistancesAndAngles(List
	 * rawData, double minAngle, double maxAngle, SCIP scip) { List<Point2D>
	 * points = new Vector<Point2D>(rawData.size());
	 * 
	 * int num = rawData.size(); double interval = scip.getInterval();
	 * 
	 * Iterator it = rawData.iterator(); double angle = minAngle; while
	 * (it.hasNext()) { int distance = ((Integer) it.next()).intValue(); Point2D
	 * point = new Point2D.Double(angle, (double) distance); points.add(point);
	 * angle += interval; }
	 * 
	 * return points; }
	 */
}