/*
 * Created on May 17, 2005
 *
 * Copyright(c) Akichika Tanaka 2005
 * 
 * 
 * URG-X002S or URG-X04LX ̃eXgvO
 * RXgN^COM̔ԍ^(s̈ΈLɂ)
 * 
 * VR}h𔭍săo[W\
 * GR}h𔭍sċX,Yɕϊ,\
 * 
 * 
 * ˑ郉CuFJava Comm APIiWinłł̂ݓmFj
 * 
 * 삵o[WFJRE 1.5.0@ȏiZLeB̃oOAJRE 1.5.0_06ȏ𐄏j
 * 삵OSFWindows XP
 * 
 * RpCɂJDK 1.5.0ȏオKv
 * 
 * License : GPL (SerialPort)
 * 
 * 
 */

import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class URGScanTest {

	private SerialPort serialPort;

	private Speed speed;

	public URGScanTest(String comm) {
		// VA|[g̏ COM̔ԍɒӁiWin̏ꍇCOM`j Xs[hUSB̏ꍇKł悢
		serialPort = new SerialPort(comm, Speed.BPS1000000.getSpeed(),
				SerialPort.DATABITS_8, SerialPort.STOPBITS_1,
				SerialPort.PARITY_NONE);

		try {
			StringBuilder builder = new StringBuilder();
			String result;

			// ////Test for V Command//////
			builder.append("V"); // VR}h
			builder.append("\n"); // End of Command

			serialPort.write(builder.toString());
			result = serialPort.read(10000);
			System.out.println(result);

			// ////Test for G Command//////
			for (int i = 0; i < 1; i++) {
				builder = new StringBuilder();
				builder.append("G"); // GR}h
				builder.append("044"); // Jn
				builder.append("725"); // I
				builder.append("01"); // ܂Ƃߌ
				builder.append("\n"); // End of Command

				// /VAփR}hM///
				serialPort.write(builder.toString());
				// /VApPbgM///
				result = serialPort.read(10000, 100);

				// /pPbgfR[h///
				ReceivePacket packet;
				packet = parse(result);
				// logger.info("Result:\n" + packet);

				// /EpxXYf[^ɕϊ///
				List<Point2D> list = null;
				if (packet != null) {
					list = ScanDataFormatter.getPoint2DListFromScanDataList(
							packet.getDistanceData(), 360.0 / 1024.0);// 擾f[^̋AXebvAXebvƂ̊pxiC^[ojXY߂

					// _X,Y\
					for (Point2D point : list) {
						System.out.println("X:" + point.getX() + " Y:"
								+ point.getY());
					}
				} else {
					System.err
							.println("ERROR:packet is null or including error code.");
				}
			}
		} finally {
			serialPort.close();
		}
	}

	private ReceivePacket parse(String result) {
		StringTokenizer tokenizer = new StringTokenizer(result, "" + (char) 10);// LF
		ReceivePacket packet = new ReceivePacket();

		if (tokenizer.countTokens() > 3) {// G[R[hȂ

			// //R}hƃp[^擾////
			String commandAndParameter = tokenizer.nextToken();
			packet.setCommand(commandAndParameter.substring(0, 1));
			packet.setParam(commandAndParameter.substring(1,
					commandAndParameter.length()));

			// /Xe[^X擾///
			packet.setStatus(tokenizer.nextToken());

			// /擾///
			StringBuilder data = new StringBuilder();
			while (tokenizer.hasMoreTokens()) {
				data.append(tokenizer.nextToken());
			}
			// /fR[h///
			packet.setDistanceData(decode(data.toString()));
			return packet;

		} else {// G[R[h̏ꍇiƏꍇ͗vύXj
			return null;
		}
	}

	final int bias = Integer.decode("0x30");// GR[hɑꂽ0x30idlj

	private ArrayList<Integer> decode(String data) {

		ArrayList<Integer> list = new ArrayList<Integer>();
		int distance;

		if (data.length() % 2 != 0) {
			for (int i = 0; i < 2 - 1; i++)
				data = data + "0";
		}

		for (int i = 0; i < data.length(); i += 2) {
			distance = 0;

			// URG̋f[^6bitɕŕԂĂ̂ŁA𓝍
			distance |= (int) data.charAt(i + 0) - bias << 6;
			distance |= (int) data.charAt(i + 1) - bias << 0;
			distance &= 0x0fff;

			// Error𖳎iƏꍇ͗vCj
			if (distance < 20)
				distance = 0;

			list.add(distance);
		}
		return list;
	}

	public static void main(String[] args) {
		if (args.length == 0)
			new URGScanTest("COM1");

		else
			new URGScanTest(args[0]);
	}
}
